/**
 * Imports
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _bindUrl = require('bind-url');

var _bindUrl2 = _interopRequireDefault(_bindUrl);

/**
 * Vars
 */

var types = ['GET_URL', 'SET_URL', 'BIND_URL'];

/**
 * Location effects
 */

function locationMiddleware(wnd) {
  wnd = wnd || window;

  return function (_ref) {
    var dispatch = _ref.dispatch;
    return function (next) {
      return function (action) {
        return types.indexOf(action.type) !== -1 ? Promise.resolve(handle(wnd, dispatch, action)) : next(action);
      };
    };
  };
}

/**
 * Handler
 */

function handle(wnd, dispatch, action) {
  switch (action.type) {
    case 'GET_URL':
      return wnd.location.pathname + wnd.location.search;
    case 'SET_URL':
      var url = wnd.location.origin + action.value;
      action.replace ? location.replace(url) : location.assign(url);
      break;
    case 'BIND_URL':
      (0, _bindUrl2['default'])({ wnd: wnd }, function (url) {
        return dispatch(action.update(url));
      });
      break;
  }
}

/**
 * Exports
 */

exports['default'] = locationMiddleware;
module.exports = exports['default'];